<template>
  <div class="edit-popup">
    <popup
      ref="popupRef"
      :title="popupTitle"
      :async="true"
      width="550px"
      @confirm="handleSubmit"
      @close="handleClose"
    >
      <el-form ref="formRef" :model="formData" label-width="84px">
        <el-col class="pt-6 !border-none">
          <el-row>
            <el-col>
              <el-form-item label="名称" prop="title">
                <el-input
                  v-model="formData.title"
                  placeholder="请输入名称"
                  clearable
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col>
              <el-form-item label="标识" prop="name">
                <el-input
                  v-model="formData.name"
                  placeholder="请输入审批类型标识"
                  clearable
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col>
              <el-form-item label="图标" prop="icon">
                <el-input
                  v-model="formData.icon"
                  placeholder="请输入审批类型图标"
                  clearable
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
        </el-col>
      </el-form>
    </popup>
  </div>
</template>

<script lang="ts" setup name="flowTypeEdit">
import type { FormInstance } from "element-plus";
import Popup from "@/components/popup/index.vue";
import { apiCateCreat } from "@/api/examined";
import { timeFormat } from "@/utils/util";
import type { PropType } from "vue";
defineProps({
  dictData: {
    type: Object as PropType<Record<string, any[]>>,
    default: () => ({}),
  },
});
const emit = defineEmits(["success", "close"]);
const formRef = shallowRef<FormInstance>();
const popupRef = shallowRef<InstanceType<typeof Popup>>();
const mode = ref("add");

// 弹窗标题
const popupTitle = computed(() => {
  return mode.value == "edit" ? "编辑审批类型" : "新增审批类型";
});

// 表单数据
const formData = reactive({
  id: "",
  type: "",
  title: "",
  name: "",
  icon: "",
  department_ids: "",
  status: "",
});

// 获取详情
const setFormData = async (data: Record<any, any>) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      //@ts-ignore
      formData[key] = data[key];
    }
  }
};

const getDetail = async (row: Record<string, any>) => {
  const data = await apiFlowTypeDetail({
    id: row.id,
  });
  setFormData(data);
};

// 提交按钮
const handleSubmit = async () => {
  const data = { ...formData };
  mode.value == "edit" ? await apiCateCreat(data) : await apiCateCreat(data);
  popupRef.value?.close();
  emit("success");
};

//打开弹窗
const open = (type = "add") => {
  mode.value = type;
  popupRef.value?.open();
};

// 关闭回调
const handleClose = () => {
  emit("close");
};

defineExpose({
  open,
  setFormData,
  getDetail,
});
</script>
